GameState = require 'hump/gamestate'
Class = require 'hump/class'
Camera = require 'hump/camera'
HC = require 'hc'

function love.load()

  love.window.setMode(1280, 720)

  love.graphics.setDefaultFilter('nearest', 'nearest')

  ship = love.graphics.newImage('assets/shipRoom.png')

  screen1 = love.graphics.newCanvas(1280, 720)
  screen2 = love.graphics.newCanvas(1280, 720)

  love.graphics.setBackgroundColor(100, 0, 100, 255)

  game = {}

  game.player = {x = 100, y = 150, width = 50, height = 50, speed = 100}
  game.player2 = {x = 300, y = 200, width = 50, height = 50, speed = 100}

  camera1 = Camera()
  camera2 = Camera()

end

function love.update(dt)

  camera1:lookAt(game.player.x+game.player.width/2, game.player.y+game.player.height/2)
  camera2:lookAt(game.player2.x+game.player2.width/2, game.player2.y+game.player2.height/2)

  if love.keyboard.isDown('w') then
    game.player.y = game.player.y - game.player.speed * dt
  elseif love.keyboard.isDown('s') then
    game.player.y = game.player.y + game.player.speed * dt
  end

  if love.keyboard.isDown('a') then
    game.player.x = game.player.x - game.player.speed * dt
  elseif love.keyboard.isDown('d') then
    game.player.x = game.player.x + game.player.speed * dt
  end

  if love.keyboard.isDown('up') then
    game.player2.y = game.player2.y - game.player2.speed * dt
  elseif love.keyboard.isDown('down') then
    game.player2.y = game.player2.y + game.player2.speed * dt
  end

  if love.keyboard.isDown('left') then
    game.player2.x = game.player2.x - game.player2.speed * dt
  elseif love.keyboard.isDown('right') then
    game.player2.x = game.player2.x + game.player2.speed * dt
  end

end

function love.draw()

  camera1:attach()

  love.graphics.setCanvas(screen1)

  love.graphics.clear()

  love.graphics.setColor(255, 255, 255, 255)
  love.graphics.draw(ship, 100, 100)

  love.graphics.setColor(255, 255, 255, 255)
  love.graphics.print('FPS: ' .. love.timer.getFPS(), 0, 0)

  love.graphics.setColor(0, 0, 150, 255)
  love.graphics.rectangle('fill', game.player.x, game.player.y, game.player.width, game.player.height)

  love.graphics.setColor(0, 100, 150, 255)
  love.graphics.rectangle('fill', game.player2.x, game.player2.y, game.player2.width, game.player2.height)

  camera1:detach()

  camera2:attach()

  love.graphics.setCanvas(screen2)

  love.graphics.clear()

  love.graphics.setColor(255, 255, 255, 255)
  love.graphics.draw(ship, 100, 100)

  love.graphics.setColor(255, 255, 255, 255)
  love.graphics.print('FPS: ' .. love.timer.getFPS(), 0, 0)

  love.graphics.setColor(0, 0, 150, 255)
  love.graphics.rectangle('fill', game.player.x, game.player.y, game.player.width, game.player.height)

  love.graphics.setColor(0, 100, 150, 255)
  love.graphics.rectangle('fill', game.player2.x, game.player2.y, game.player2.width, game.player2.height)

  love.graphics.setCanvas()

  camera2:detach()

  love.graphics.setColor(255, 255, 255, 255)
  love.graphics.print('FPS: ' .. love.timer.getFPS(), 0, 0)

  love.graphics.setColor(255, 255, 255, 255)
  love.graphics.setScissor(0, 0, 640, 720)
  love.graphics.draw(screen1, -love.graphics.getWidth()/4)
  love.graphics.setScissor(640, 0, 640, 720)
  love.graphics.draw(screen2, love.graphics.getWidth()/4)
  love.graphics.setScissor()

end
